#include "Ai8051U.h"
#include "def.h"
#include "stdio.h"


// ꡢ
#define FALSE 0
#define TRUE 1
#define MINBAUD 2400L
#define MAXBAUD 115200L
#define FOSC 11059200L // оƬƵ
#define BR(n) (65536 - (FOSC / (n) + 2) / 4) 		// оƬڲʼ㹫ʽ
																								//  2 Ϊ Keil 
																								// Զʵ

#define FUSER 24000000L													// Ai8051U ϵĿоƬƵ
#define RL(n) (65536 - (FUSER / (n) + 2) / 4)		// Ai8051U ϵĿоƬڲʼ㹫ʽ
																								//  2 Ϊ Keil 
																								// Զʵ
#define Timer0_Reload   (65536UL -(FOSC / 1000))       //Timer 0 жƵ, 1000/
#define Baudrate1   115200UL
// 
BOOL f1ms;                          // 1ms ־λ
BOOL UartBusy;                      // ڷæ־λ
BOOL UartReceived;                  // ݽɱ־λ
BYTE UartRecvStep;                  // ݽտ
BYTE TimeOut;                       // ͨѶʱ
BYTE xdata TxBuffer[256];           // ݷͻ
BYTE xdata RxBuffer[256];           // ݽջ
char code DEMO[256];

// 
void Initial(void);
void DelayXms(WORD x);
BYTE UartSend(BYTE dat);
void CommInit(void);
void CommSend(BYTE size);
BOOL Download(BYTE *pdat, long size);

// 
void main(void)
{
	
    P3M0 = 0x00;
    P3M1 = 0x00;
    P2M0 = 0x00;
    P2M1 = 0x00;		
	
    Initial();
		P2 = 0x0F;
    if (Download(DEMO, 256))
    {
			P27=0;
			DelayXms(500);
			P27=1;
			DelayXms(500);
			P27=0;
			DelayXms(500);
			P27=1;
			DelayXms(500);
			P27=0;
			DelayXms(500);
			P27=1;
			DelayXms(500);
    }
    else
    {
      // ʧ
			P2 = 0xFF;

    }
		DelayXms(500);
		DelayXms(500);
		DelayXms(500);
		DelayXms(500);
    
}

// 1msʱжϷ
void tm0(void) interrupt 1
{
    static BYTE Counter100;
    f1ms = TRUE;
    if (Counter100-- == 0)
    {
        Counter100 = 100;
        if (TimeOut>0){
            TimeOut--;
            //P26=0;
        }
            
    }
		
}

// жϷ
void uart(void) interrupt 4
{
    static WORD RecvSum;
    static BYTE RecvIndex;
    static BYTE RecvCount;
    BYTE dat;

    if (TI)
    {
        TI = 0;
        UartBusy = FALSE;
    }
    if (RI)
    {
        RI = 0;
        dat = SBUF;
        switch (UartRecvStep)
        {
        case 1:
            if (dat != 0xb9)
                goto L_CheckFirst;
            UartRecvStep++;
            break;
        case 2:
            if (dat != 0x68)
                goto L_CheckFirst;
            UartRecvStep++;
            break;
        case 3:
            if (dat != 0x00)
                goto L_CheckFirst;
            UartRecvStep++;
            break;
        case 4:
            RecvSum = 0x68 + dat;
            RecvCount = dat - 6;
            RecvIndex = 0;
            UartRecvStep++;
            break;
        case 5:
            RecvSum += dat;
            RxBuffer[RecvIndex++] = dat;
            if (RecvIndex == RecvCount)
            {
                UartRecvStep++;
            }
            break;
        case 6:
            if (dat != HIBYTE(RecvSum))
                goto L_CheckFirst;
            UartRecvStep++;
            break;
        case 7:
            if (dat != LOBYTE(RecvSum))
                goto L_CheckFirst;
            UartRecvStep++;
            break;
        case 8:
            if (dat != 0x16)
                goto L_CheckFirst;
            UartReceived = TRUE;
            UartRecvStep++;
            break;
        L_CheckFirst:
        case 0:
        default:
            CommInit();
            UartRecvStep = (dat == 0x46 ? 1 : 0);
            break;
        }
    }
}





// ϵͳʼ
void Initial(void)
{
		P_SW2 |= 0x80;     //չĴ(XFR)ʹ
    RSTFLAG |= 0x04;   //ӲλҪP3.2״̬ѡ򣬷ӲλUSBģʽ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

	
    UartBusy = FALSE;
		UartRecvStep = 0;
	  //Timer0ʼ
    TMOD &= 0xf0;//16 bits timer auto-reload
    AUXR |= 0x80;//Timer0 set as 1T
	
    TH0 = (u8)(Timer0_Reload / 256);
    TL0 = (u8)(Timer0_Reload % 256);
    ET0 = 1;    //Timer0 interrupt enable
    TR0 = 1;    //Tiner0 run
		
		
		TR1 = 0;
		AUXR &= ~0x01;      //S1 BRT Use Timer1;
		AUXR |=  (1<<6);    //Timer1 set as 1T mode
		TMOD &= ~(1<<6);    //Timer1 set As Timer
		TMOD &= ~0x30;      //Timer1_16bitAutoReload;
    TH1 = HIBYTE(BR(MINBAUD));
    TL1 = LOBYTE(BR(MINBAUD));

		ET1 = 0;    //ֹж
		INTCLKO &= ~0x02;  //ʱ
		TR1  = 1;

    ES  = 1;    //ж
    REN = 1;    //
    P_SW1 &= 0x3f;
    P_SW1 |= 0x40;      //UART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4
		//SCON = (SCON & 0x3f) | 0x40;    //UART1ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
		SCON = 0xd0;// 8λ+1λżУ

    EA = 1;
}

// Xms ʱ
void DelayXms(WORD x)
{
    do
    {
        f1ms = FALSE;
        while (!f1ms)
            ;
    } while (x--);
}

// ݷͳ
BYTE UartSend(BYTE dat)
{
    while (UartBusy)
        ;
    UartBusy = TRUE;
    ACC = dat;
    TB8 = P;
    SBUF = ACC;
    return dat;
}

// ͨѶʼ
void CommInit(void)
{
    UartRecvStep = 0;
    TimeOut = 20;
    UartReceived = FALSE;
}

// ʹͨѶݰ
void CommSend(BYTE size)
{
    WORD sum;
    BYTE i;
    UartSend(0x46);
    UartSend(0xb9);
    UartSend(0x6a);
    UartSend(0x00);
    sum = size + 6 + 0x6a;
    UartSend(size + 6);
    for (i = 0; i < size; i++)
    {
        sum += UartSend(TxBuffer[i]);
    }
    UartSend(HIBYTE(sum));
    UartSend(LOBYTE(sum));
    
		UartSend(0x16);
    while (UartBusy);
    CommInit();
}

//  Ai8051U ϵеоƬ ISP س
BOOL Download(BYTE *pdat, long size)
{
    BYTE offset;
    BYTE cnt;
    DWORD addr; //  64K ռ䣬ַ趨Ϊ 4 ֽ

    while (1)
    {
        if (UartRecvStep == 0)
        {
            UartSend(0x7f);
            DelayXms(10);
        }
        if (UartReceived)
        {
            if (RxBuffer[0] == 0x50)
                break;
            return FALSE;
        }
    }
		P2 = 0xFF;
		

    // ò(ôоƬʹߵĲ)
    TxBuffer[0] = 0x01;
    TxBuffer[1] = 0x00;
    TxBuffer[2] = 0x00;
    TxBuffer[3] = HIBYTE(RL(MAXBAUD));
    TxBuffer[4] = LOBYTE(RL(MAXBAUD));
    TxBuffer[5] = 0x00;
    TxBuffer[6] = 0x00;
    TxBuffer[7] = 0x97;
    CommSend(8);
		P20 = 0;
    while (1)
    {
        if (TimeOut == 0)
            return FALSE;
        
        if (UartReceived)
        {
            if (RxBuffer[0] == 0x01)
                break;
            return FALSE;
        }
    }
		P21 = 0;
    // ׼
    TH1 = HIBYTE(BR(MAXBAUD));
    TL1 = LOBYTE(BR(MAXBAUD));
    DelayXms(10);
    TxBuffer[0] = 0x05;
    TxBuffer[1] = 0x00;
    TxBuffer[2] = 0x00;
    TxBuffer[3] = 0x5a;
    TxBuffer[4] = 0xa5;
    CommSend(5);
    while (1)
    {
        if (TimeOut == 0)
            return FALSE;
        if (UartReceived)
        {
            if (RxBuffer[0] == 0x05)
                break;
            return FALSE;
        }
    }
		P22 = 0;
    // 
    DelayXms(10);
    TxBuffer[0] = 0x03;
    TxBuffer[1] = 0x00;
    TxBuffer[2] = 0x00;
    TxBuffer[3] = 0x5a;
    TxBuffer[4] = 0xa5;
    CommSend(5);
    TimeOut = 100;
    while (1)
    {
        if (TimeOut == 0)
            return FALSE;
        if (UartReceived)
        {
            if (RxBuffer[0] == 0x03)
                break;
            return FALSE;
        }
    }
		P23 = 0;
    // дû
    DelayXms(10);
    addr = 0;
    TxBuffer[0] = 0x22;
    TxBuffer[3] = 0x5a;
    TxBuffer[4] = 0xa5;
    offset = 5;
    while (addr < size)
    {
        if (addr < 0x100000)
        // ĿַϢԭHEXļлȡ
        {
            TxBuffer[0] |= 0x10;
            // Ŀ̵ַΪFE:0000~FE:FFF
        }
        else
        {
            TxBuffer[0] &= -0x10;
            // Ŀ̵ַΪFF:0000~FF:FFF
        }

        TxBuffer[1] = HIBYTE(addr);
        TxBuffer[2] = LOBYTE(addr);
        cnt = 0;
        while (addr < size)
        {
            TxBuffer[cnt + offset] = pdat[addr];
            addr++;
            cnt++;
            if (cnt >= 128)
                break;
        }
        CommSend(cnt + offset);
        while (1)
        {
            if (TimeOut == 0)
                return FALSE;
            if (UartReceived)
            {
                if ((RxBuffer[0] == 0x02) && (RxBuffer[1] == 'T'))
                    break;
                return FALSE;
            }
        }
        TxBuffer[0] = 0x02;
    }
		P24 = 0;
    // 
    return TRUE;
}

// ʾ
char code DEMO[256] =
    {
        0x80,
        0x00,
        0x75,
        0xB2,
        0xFF,
        0x75,
        0xB1,
        0x00,
        0x05,
        0xB0,
        0x11,
        0x0E,
        0x80,
        0xFA,
        0xD8,
        0xFE,
        0xD9,
        0xFC,
        0x22,
};

